unit untBBS2chKako;

interface

uses
  Classes, Dialogs, SysUtils,
  IdComponent, IdTCPConnection, IdTCPClient, IdHTTP,
  IdCookieManager,
  RegExpr, DzURL,
  untStreamTool, untTool,
  untBBSFramework, untBBS2ch,
  untLoginForm;

type

  TBBS2chGetKakoTopic = class(TBBS2chGetTopic)
  protected
    function GetURL: string; override;
  public
    IsExist: Boolean;
    constructor Create(Server, BoardId, TopicId : string);
    procedure HttpComplete(Sender: TObject); override;
  end;

implementation

{ TBBS2chGetKakoTopic }

procedure TBBS2chGetKakoTopic.HttpComplete(Sender: TObject);
begin
  inherited;

  if FHttp.ResponseCode <> 302 then
  begin
    IsExist := true;
  end;
end;

constructor TBBS2chGetKakoTopic.Create(Server, BoardId, TopicId: string);
begin
  inherited Create(Server, BoardId, TopicId);

  FHttp.UseGzip := true;
  FRawMode := true;
  IsExist := false;
end;

function TBBS2chGetKakoTopic.GetURL: string;
begin
  if Length(FTopicId) > 9 then
    result := 'http://' + FServer + '/' + FBoardId + '/kako/' + Copy(FTopicId, 1, 4)
                     + '/' + Copy(FTopicId, 1, 5) + '/' + FTopicId + '.dat.gz'
  else
    result := 'http://' + FServer + '/' + FBoardId + '/kako/' + Copy(FTopicId, 1, 3)
                     + '/' + FTopicId + '.dat.gz';
end;

end.
